Index: res_musiconhold.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_musiconhold.c,v
retrieving revision 1.4
diff -u -r1.4 res_musiconhold.c
--- res_musiconhold.c	7 Aug 2003 03:48:00 -0000	1.4
+++ res_musiconhold.c	9 Aug 2003 20:40:08 -0000
@@ -574,13 +574,22 @@
 static void ast_moh_destroy(void)
 {
 	struct mohclass *moh;
+	char buff[8192];
+	int bytes, tbytes, stime = 0;
 	if (option_verbose > 1)
 		ast_verbose(VERBOSE_PREFIX_2 "Destroying any remaining musiconhold processes\n");
 	ast_pthread_mutex_lock(&moh_lock);
 	moh = mohclasses;
 	while(moh) {
 		if (moh->pid) {
-			kill(moh->pid, SIGKILL);
+			ast_log(LOG_DEBUG, "killing %d!\n", moh->pid);
+			stime = time(NULL);
+			kill(moh->pid, SIGABRT);
+			while (bytes = read(moh->srcfd, buff, 8192) && time(NULL) < stime + 5) {
+				tbytes = tbytes + bytes;
+			}
+			ast_log(LOG_DEBUG, "mpg123 pid %d and child died after %d bytes read\n", moh->pid, tbytes);
+			close(moh->srcfd);
 			moh->pid = 0;
 			}
 		moh = moh->next;
